'*******************************************************************************
'  EERAM SETUP                         'SVN Rev.227 09.01.2011
'*******************************************************************************
'
'  Copyright bascom-forum.de (C) [2009]  [DON]
'  -> http://bascom-forum.de/index.php?topic=1781.new;topicseen#new
'  Software based on Code by Ben Zijlstra and Viktor Varga
'  Weiterentwickelt von
'    Huetti,
'    Michael
'    boeserkorn
'    mr_energy
'    HansHans
'    six1, Michael Kcher
'    dabuze                            datetime
'    framuel
'    tfv
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'

'*******************************************************************************
$nocompile

'*******************************************************************************
'  Update der Freesol-Werte
'*******************************************************************************
Sub Fs_freesol_update
   Local Svor As Integer
   Local Ltemp As Long
   Local Ltemp2 As Long
   Local Ltemp3 As Long
   Local Offs As Integer
   Local Offsmin As Integer
   Local Offsmin2 As Integer
   Local Offsmin3 As Integer
   Local Pzt As Long
   Local I As Integer
   Local J As Integer
   Local L As Long
   Local L2 As Long
   Local W As Word
   Local S2 As String * 10
   Local S3 As String * 10
   Local S4 As String * 10
   Local S As Single
   Local Ind_be As Integer
   Local Temp As Integer
   Local Flag As Integer

   S2 = Date(netio_time)
   S4 = Time(netio_time)
   Print "Heartbeat: " ; S2 ; " " ; S4 ; " " ; " " ; Str(my_b_ipaddr(1)) ; "." ; Str(my_b_ipaddr(2)) ; "." ; Str(my_b_ipaddr(3)) ; "." ; Str(my_b_ipaddr(4))       '
   Print "    Start:  " ; Fs_startzeit_ntp ; " S0: " ; Fs_pulszahl
#if Debug_freesol
   S2 = Date(netio_time)
   L = Sysday(netio_time)
   Print "fs_freesol_update: Date(netio_time): " ; S2 ; " " ; L
     #if Fs_debugvar = 1
      If Fs_ersteraufruf = 0 Then
         Fs_ersteraufruf = 1                                ' Nur einmal ausfhren
         Print "Eprom-Werte von Freesol"
         Fs_eeram_lesen
      End If
    #endif
    #if Fs_debugvar = 2
       If Fs_ersteraufruf = 0 Then
         Fs_ersteraufruf = 1
         Fs_eeram_loeschen
         Print "Eprom-Werte von Freesol geloescht"
         Fs_eeram_lesen
       End If
    #endif
     #if Fs_debugvar = 3
       If Fs_ersteraufruf = 0 Then
         Fs_ersteraufruf = 1
         Fs_eeram_dummy
         Print "Eprom-Werte von Freesol mit Dummy belegt"
         Fs_eeram_lesen
       End If
    #endif
#endif
   If Fs_alarmmailflag2 = 1 Then
    If Fs_alarmmailflag = 0 Then
      If Fs_mailstatus = 0 Then
          Print "Alarmmailversand"
          Fs_mailstatus = 2
          Smtp_mail_versand_in = 1
          Fs_alarmmailflag2 = 0
      End If
    End If
   Else
    If Fs_alarmmailflag = 1 Then
      Fs_alarmmailflag2 = 1
    End If
   End If

    L = Sysday(netio_time)
    If Ntp_valid = 1 Then                                   'Verbessert: Nur bei gltiger Zeit; alt: L > 4300 Then (Datum im Jahr 2011)
      If Fs_ersteraufruf = 0 Then
         Fs_ersteraufruf = 1
         Fs_eeram_lesen
      End If
      Fs_tagesmax = 0
      For J = 99 To 0 Step -1                               '9
         L = Fs_speicherdatum_tage - J
         W = L
         S2 = Date(w)
         L2 = L Mod 100                                     ' 5-8-12 Bug korrigiert (1)
         I = L2
         If I = 0 Then                                      ' 5-8-12 Bug korrigiert (1)
            I = 100
         End If
         If Fs_tageswerte(i) > 0 Then
            Fs_tagesmax = J + 1
            J = 0
         End If
      Next J

      Offs = _hour + 1
      Pzt = Fs_pulszahl
      If Offs > 0 Then
         If Offs < 23 Then                                  ' Bei Stunde 24 wird das nicht mehr gemacht!
               Svor = Offs - 1
               Fs_stundenstart(offs) = Pzt
               If Svor = 0 Then
                  Ltemp = Fs_stundenstart(offs)
               Else
                  Ltemp = Fs_stundenstart(svor )
               End If
               Ltemp2 = Fs_stundenstart(offs )
               Fs_stundenwerte(offs) = Ltemp2 - Ltemp
         End If
      End If
      If Offs > 0 Then                                      ' 5min S0 Werte eintragen
         If Offs < 25 Then
            Ltemp = Fs_minlast
            Ltemp2 = Pzt
            Offsmin = _min
            Offsmin2 = Offsmin / 5
            Offsmin2 = Offsmin2 * 5
            #if Debug_freesol
             Print Offsmin2 ; "  " ; Offsmin ; "  " ; Ltemp2 ; "  " ; Ltemp
            #endif
            Ltemp3 = Ltemp2 - Fs_minlast_min
            Fs_akt_leist_min = Ltemp3 / Fs_pulsfaktor
            Fs_akt_leist_min = Fs_akt_leist_min * 60
            Fs_minlast_min = Ltemp2
            If Offsmin2 = Offsmin Then                      ' Alle 5 min ausgefhrt
               Offsmin2 = Offsmin / 5
               Fs_min_j = Offsmin2
               Offsmin3 = Offs - 1                          'neu: -1 statt -5 'Offsmin3=0 fr 4 Uhr
               Fs_min_i = Offsmin3
               Offsmin3 = Offsmin3 * 12
               Offsmin3 = Offsmin3 + Offsmin2
               Fs_minlast = Ltemp2
               Ltemp2 = Ltemp2 - Ltemp
               If Offsmin3 > 0 Then
                  Fs_minw(offsmin3) = Ltemp2                ' Routine speichert ersten Wert um 4.00 Uhr fr die 5 min davor  ;Speicherindex startet bei 0, sinnvolle Werte aber erst ab 1
                  Ee_fs_minw(offsmin3) = Fs_minw(offsmin3)
               End If
               Fs_akt_leist = Ltemp2 / Fs_pulsfaktor
               Fs_akt_leist = Fs_akt_leist * 12
               S = Fs_akt_leist * 1000
               J = S
               If J > Fs_schaltschwelle Then                'akt. Leistung liegt ber Schaltschwelle
                     Fs_schaltdauertemp = Fs_schaltdauer    ' Falls Signal schon an war, bleibt es wieder Schaltdauer an. Falls noch nicht an, wird es angeschalten. Falls Schaltdauer=0, bleibt es damit aus, weil spter Schaltdauer abgefragt wird
                     Fs_schaltsignal = 1                    ' Ausgang einschalten
               Else
                  If Fs_schaltdauertemp > 0 Then
                     Fs_schaltdauertemp = Fs_schaltdauertemp - 1
                  End If
                  If Fs_schaltdauertemp = 0 Then
                     Fs_schaltsignal = 0                    'Ausgang ausschalten
                  End If

               End If
                Fs_minpos = Offsmin3
            End If
         End If
      End If


      Offsmin = _min
      Offsmin2 = Offsmin / 5
      Offsmin2 = Offsmin2 * 5

      If Offsmin2 = Offsmin Then
         If Fs_maildebugflag = 1 Then
                  If Ntp_valid = 1 Then
                    Fs_mail_datum = Date$
                  Else
                    Fs_mail_datum = "01.01.11"
                  End If
                  Fs_mail_energie = 88888
                  Fs_mail_energienorm = Fs_mail_energie / Fs_anlagenleistung
                  Smtp_mail_versand_in = 1
                  Print "Testmail senden"
                  #if System_message > 0
                     Print "Mail_versand_in = " ; Smtp_mail_versand_in ; " Minuten "
                  #endif
          End If
      End If

      If Offs = 24 Then                                     '24 Vorschub um 23.56 Uhr
         If _min = 56 Then                                  '56
           ' Aktuellen Tag schreiben
            Fs_eeram_akt_tag_speich
         End If

      End If

      If Offs = 2 Then                                      '1 Booten nachts um 01.17 (nicht zwischen 0 und ein Uhr, sonst Probleme bei Zeitumstellungm, da zwei Boots)
         If _min = 17 Then                                  '30
           ' Booten ber Watchdog
            Wait 10
         End If
       End If

   Else                                                     ' auch ohne erfolgreiche Zeitsynchrionisierung nach 30 min rebooten
       If _min > 30 Then                                    '30
           ' Booten ber Watchdog
            Wait 10
       End If
   End If
End Sub


'*******************************************************************************
'  Freesol-Werte aus Eeram lesen
'*******************************************************************************
Sub Fs_eeram_lesen
   Local I As Integer
   Local J As Integer
   Local K As Integer
   Local K1 As Integer
   Local L As Long
   Local L1 As Long
   Local L2 As Long
   Local D As Long


   Fs_anlagenleistung = Ee_fs_anlagenleistung

   If Fs_anlagenleistung = 0 Then
      Print "Fehler: Fs-anlagenleistung = 0"
   End If

   Fs_speicherdatum_tage = Ee_fs_speicherdatum_tage

   ' Hier wird ein mglicher fehler aus ungltigen (negativen) Fs_speicherdatum_tage abgefangen
   If Fs_speicherdatum_tage < 0 Then
      Fs_speicherdatum_tage = 0
      Ee_fs_speicherdatum_tage = Fs_speicherdatum_tage
   End If

   'Prfen, ob ungltige Werte im Eram vorliegen, und diese ggf berschreiben
   'Diese Routine ist ungetestet
   L = Sysday(netio_time)                                   'war Sysday(netio_time)
   L = L - 1

   If L > Fs_speicherdatum_tage Then                        ' Hier werden Vortage im Ringspeicher auf 0 gesetzt, falls an diesen kein Wert abgespeichert wurde
      L2 = L - Fs_speicherdatum_tage
      If L2 > 100 Then
         L2 = L - 100
      Else
         L2 = Fs_speicherdatum_tage + 1
      End If
      For L1 = L2 To L
          D = L1 Mod 100
          I = D                                             ' 5-8-12 Bug korrigiert (2)
          If I = 0 Then                                     ' 5-8-12 Bug korrigiert (2)
            I = 100
          End If
          Ee_fs_tageswerte(i) = 0
          Fs_tageswerte(i) = 0
      Next L1
      Fs_speicherdatum_tage = L
      Ee_fs_speicherdatum_tage = Fs_speicherdatum_tage
   End If

   'Werte Einlesen
   For I = 1 To 100
      Fs_tageswerte(i) = Ee_fs_tageswerte(i)
   Next I

#if Debug_freesol
   For I = 1 To 10
      Print "Tageswerte: " ; Str(i) ; "  " ; Str(fs_tageswerte(i))
   Next I
   Print "Speicherdatum Tage: " ; Str(fs_speicherdatum_tage )
#endif
   Fs_speicherdatum_monate = Ee_fs_speicherdatum_monate
   Fs_monatswerte = Ee_fs_monatswerte
#if Debug_freesol
   Print "Monatswerte Vormonat: " ; Str(fs_monatswerte) ; "  Speicherdatum: " ; Str(fs_speicherdatum_monate )
#endif
   Fs_speicherdat_lfdmon = Ee_fs_speicherdat_lfdmon
   Fs_lfdmonwerte = Ee_fs_lfdmonwerte
#if Debug_freesol
   Print "Monatswerte aktuell: " ; Str(fs_lfdmonwerte) ; "  Speicherdatum: " ; Str(fs_speicherdat_lfdmon )
#endif

   Fs_pulszahlges = Ee_fs_pulszahlges
   Fs_pulsfaktor = Ee_fs_pulsfaktor
   Fs_lcd = Ee_fs_lcd
   Fs_maildebugflag = Ee_fs_maildebugflag

   Fs_schaltschwelle = Ee_fs_schaltschwelle
   Fs_alarmmailtext = Ee_fs_alarmmailtext
   Fs_schaltdauer = Ee_fs_schaltdauer

   Fs_speicherdatum_minuten = Ee_fs_speicherdatum_minuten

   L = Sysday(netio_time)                                   'war Sysday(netio_time)
   If Fs_speicherdatum_minuten = L Then                     'Minutenwerte wurden heute schon mal gespeichert, wieder reinholen
      For I = 1 To 288                                      '216
         Fs_minw(i) = Ee_fs_minw(i)
      Next I
      L1 = 0                                                'Stundenwerte rekonstruieren
      For I = 1 To 24
         Fs_stundenstart(i) = 0
         Fs_stundenwerte(i) = 0
      Next
      K1 = _hour
      K1 = K1 + 1
      If K1 > 4 Then
         For I = 5 To K1
            L = 0
            For J = 1 To 12
              K = I - 5
              K = K * 12
              K = K + J
              L = L + Fs_minw(k)
            Next J
            Fs_stundenstart(i) = L1 + L
            Fs_stundenwerte(i) = L
            L1 = L1 + L
         Next
         Fs_pulszahl = Fs_pulszahl + Fs_stundenstart(k1)
         Fs_minlast = Fs_stundenstart(k1)
      End If
   Elseif _hour = 1 Then                                       'Fall dass es Nachts um 1.17 ist und grade gebootet wurde, hier Minutenwerte neu reinholen
       For I = 1 To 15                                      '216
         Fs_minw(i) = Ee_fs_minw(i)
      Next I
      L1 = 0                                                'Stundenwerte rekonstruieren
      For I = 1 To 24
         Fs_stundenstart(i) = 0
         Fs_stundenwerte(i) = 0
      Next
      K1 = _hour
      K1 = K1 + 1
         For I = 1 To K1
            L = 0
            For J = 0 To 12
              K = I - 1
              K = K * 12
              K = K + J
              L = L + Fs_minw(k)
            Next J
            Fs_stundenstart(i) = L1 + L
            Fs_stundenwerte(i) = L
            L1 = L1 + L
         Next
         Fs_pulszahl = Fs_pulszahl + Fs_stundenstart(k1)
         Fs_minlast = Fs_stundenstart(k1)

      For I = 16 To 288                                     '216
            Fs_minw(i) = 0
            Ee_fs_minw(i) = 0
      Next I
   Else                                                     'Minutenwerte auch im Eprom lschen
      For I = 1 To 288                                      '216
         Fs_minw(i) = 0
         Ee_fs_minw(i) = 0
      Next I
      Fs_speicherdatum_minuten = L
      Ee_fs_speicherdatum_minuten = Fs_speicherdatum_minuten
   End If

  ' Vortageswerte laden
   Fs_speichdat_vt_t = Ee_fs_speichdat_vt_t

   For J = 1 To 288                                         '216
      Fs_minw_vt(j) = Ee_fs_minw_vt(j)
   Next J

End Sub


'*******************************************************************************
'  Freesol-Werte am aktuellen Tag ins Eram speichern
'*******************************************************************************
Sub Fs_eeram_akt_tag_speich
   Local I As Integer
   Local J As Integer
   Local K As Integer
   Local L As Integer
   Local D As Long
   Local D2 As Long
   Local Tag As Long
   Local Wsysday As Word
   Local S As String * 9

   Reset Watchdog
   #if System_message > 0
      Print "Routine Eeram aktuellen Tag speichern"
   #endif

   '( Ungetestet. Wird jetzt beim Einlesen gemacht
   ' Prfen, ob letztes Speicherdatum lter als Vortag
   D = Sysday(netio_time)
   D = D - 1
   If D > Fs_speicherdatum_tage Then
      D2 = Fs_speicherdatum_tage + 1
      For Tag = D2 To D
       L = Tag
       Fs_tageswerte(l) = 0
       Ee_fs_tageswerte(l) = 0
      Next
   End If
')

   ' Den Wert des heutigen Tages am Abend speichern
   Fs_speicherdatum_tage = Sysday(netio_time)               'war Sysday(netio_time)
   Ee_fs_speicherdatum_tage = Fs_speicherdatum_tage
   D = Fs_speicherdatum_tage Mod 100                        ' 5-8-12 Bug korrigiert (4)
   I = D
   If I = 0 Then                                            ' 5-8-12 Bug korrigiert (4)
      I = 100
   End If

   D = Fs_pulszahl - Fs_stundenstart(1)
   D2 = D / 10
   D2 = D2 * 10
   D2 = D - D2
   D = D / 10
   If D2 > 4 Then
      D = D + 1
   End If
   D = D * 1000
   D = D / Fs_pulsfaktor
   Fs_tageswerte(i) = D
   Ee_fs_tageswerte(i) = Fs_tageswerte(i)


   ' Zhlerstand speichern
   Fs_pulszahlges = Fs_pulszahlges + Fs_pulszahl
   Ee_fs_pulszahlges = Fs_pulszahlges

   ' Vortageswerte speichern
   Fs_speichdat_vt_t = Fs_speicherdatum_tage
   Ee_fs_speichdat_vt_t = Fs_speichdat_vt_t


   For J = 1 To 288                                         '216
      Ee_fs_minw_vt(j) = Fs_minw(j)
   Next J

   Reset Watchdog



   ' Werte des aktuellen Tages lschen
   For J = 1 To 24
      Fs_stundenwerte(j) = 0
      Fs_stundenstart(j) = 0
   Next J

   For J = 1 To 288                                         ' 216
      Fs_minw_vt(j) = Fs_minw(j)                            '16.5.12 eingefgt
      Fs_minw(j) = 0
   Next J

   Reset Watchdog

   ' Mail lostreten
   Fs_mail_datum = Date$
   Fs_mail_energie = Fs_tageswerte(i) * 10
   Fs_mail_energienorm = Fs_mail_energie / Fs_anlagenleistung

   If Fs_mailstatus = 0 Then
      Fs_mailstatus = 1
      Smtp_mail_versand_in = 1
   End If

   #if System_message > 0
      Print "Mail_versand_in = " ; Smtp_mail_versand_in ; " Minuten "
   #endif


   ' laufenden Monat speichern
   Fs_lfdmonwerte = 0
   For L = 1 To _day
      K = 101 - L
      K = K + I                                             ' Achtung, I wird von oben bernommen! ' 5-8-12 Bug korrigiert (5)
      K = K Mod 100
      If K = 0 Then                                         ' 5-8-12 Bug korrigiert (5)
         K = 100
      End If
      Fs_lfdmonwerte = Fs_lfdmonwerte + Fs_tageswerte(k)
   Next J
   Fs_lfdmonwerte = Fs_lfdmonwerte * 10
   Fs_speicherdat_lfdmon = Sysday(netio_time)               'war sysday
   Ee_fs_speicherdat_lfdmon = Fs_speicherdat_lfdmon
   Ee_fs_lfdmonwerte = Fs_lfdmonwerte


    ' Feststellen ob Monatserster
   Tag = Sysday(netio_time)                                 'war Sysday(netio_time)
   Wsysday = Tag
   Wsysday = Wsysday + 1
   S = Date(wsysday)
   S = Left(s , 2)
   Tag = Val(s)

   If Tag = 1 Then
       ' Falls erster Tag im Monat, dann die zuletzt abgespeicherten Werte des aktuellen Monats als Monatswerte speichern
       Fs_speicherdatum_monate = Fs_speicherdat_lfdmon
       Ee_fs_speicherdatum_monate = Fs_speicherdatum_monate
       Fs_monatswerte = Fs_lfdmonwerte
       Ee_fs_monatswerte = Fs_monatswerte
   End If

   Reset Watchdog

   #if System_message > 0
      Print "Routine Eeram aktuellen Tag speichern beendet"
   #endif


End Sub


'*******************************************************************************
'  Freesol-Werte im Eram lschen
'*******************************************************************************
Sub Fs_eeram_loeschen
Local I As Integer
Local Wsysday As Word
Local S As String * 9
Local J As Integer
   Wsysday = Sysday(netio_time)                             'war sysday
   Fs_speicherdatum_tage = 1000
   Fs_speicherdatum_tage = Fs_speicherdatum_tage - 1
   For I = 1 To 100
      Fs_tageswerte(i) = 0
   Next I
   Wsysday = Sysday(netio_time)                             'war sysday
   S = Date(wsysday)
   S = Left(s , 2)
   J = Val(s)
   Fs_speicherdatum_monate = Wsysday - J
   Fs_monatswerte = 0
   Fs_speicherdat_lfdmon = Sysday(netio_time)
   Fs_speicherdat_lfdmon = Fs_speicherdat_lfdmon - 1
   Fs_lfdmonwerte = 0

   Ee_fs_speicherdatum_tage = Fs_speicherdatum_tage
   #if Debug_freesol
   Print "Speicherdatum Tage geschrieben: " ; Fs_speicherdatum_tage
   #endif
   For I = 1 To 100
      Ee_fs_tageswerte(i) = Fs_tageswerte(i)
   Next I
   Ee_fs_speicherdatum_monate = Fs_speicherdatum_monate
   #if Debug_freesol
      Print "Speicherdatum Monate geschrieben: " ; Fs_speicherdatum_monate
   #endif
   Ee_fs_monatswerte = Fs_monatswerte
   Ee_fs_speicherdat_lfdmon = Fs_speicherdat_lfdmon
   Ee_fs_lfdmonwerte = Fs_lfdmonwerte
   #if Debug_freesol
      Print "Speicherdatum lfdMonat geschrieben: " ; Fs_speicherdat_lfdmon
   #endif

   Fs_pulszahlges = 0
   Ee_fs_pulszahlges = 0



End Sub

'*******************************************************************************
'  Freesol-Werte im Eram mit dummy belegen
'*******************************************************************************
Sub Fs_eeram_dummy
Local I As Integer
Local Wsysday As Word
Local S As String * 9
Local J As Integer
   Wsysday = Sysday(netio_time)
   Fs_speicherdatum_tage = Sysday(netio_time)
   Fs_speicherdatum_tage = Fs_speicherdatum_tage - 1
   For I = 1 To 100
      Fs_tageswerte(i) = I
   Next I
   Wsysday = Sysday(netio_time)
   S = Date(wsysday)
   S = Left(s , 2)
   J = Val(s)
   Fs_speicherdatum_monate = Wsysday - J
   Fs_monatswerte = 0
   Fs_speicherdat_lfdmon = Sysday(netio_time)
   Fs_speicherdat_lfdmon = Fs_speicherdat_lfdmon - 1
   Fs_lfdmonwerte = 0

   Ee_fs_speicherdatum_tage = Fs_speicherdatum_tage
   #if Debug_freesol
   Print "Speicherdatum Tage geschrieben: " ; Fs_speicherdatum_tage
   #endif
   For I = 1 To 100
      Ee_fs_tageswerte(i) = Fs_tageswerte(i)
   Next I
   Ee_fs_speicherdatum_monate = Fs_speicherdatum_monate
   #if Debug_freesol
      Print "Speicherdatum Monate geschrieben: " ; Fs_speicherdatum_monate
   #endif
   Ee_fs_monatswerte = Fs_monatswerte
   Ee_fs_speicherdat_lfdmon = Fs_speicherdat_lfdmon
   Ee_fs_lfdmonwerte = Fs_lfdmonwerte
   #if Debug_freesol
      Print "Speicherdatum lfdMonat geschrieben: " ; Fs_speicherdat_lfdmon
   #endif

   Fs_pulszahlges = 0
   Ee_fs_pulszahlges = 0
End Sub

'*******************************************************************************
'  3-Segmentanzeige updaten (Spezielle Anzeige fr Verein in Erlangen)
'*******************************************************************************
Sub Fs_lcd_update_3seg
   Local Fs_lcd_aktleist As Single
   Local Fs_lcd_aktleist_int As Integer
   Local I As Integer
   Local B As Byte

   Fs_lcd_letzte_pulszahl = Fs_lcd_diese_pulszahl
   Fs_lcd_diese_pulszahl = Fs_pulszahl

   Fs_lcd_aktleist = Fs_lcd_diese_pulszahl - Fs_lcd_letzte_pulszahl
   Fs_lcd_aktleist = Fs_lcd_aktleist * 100
   Fs_lcd_aktleist = Fs_lcd_aktleist / Fs_pulsfaktor
   Fs_lcd_aktleist = Fs_lcd_aktleist * 60                   ' Hier steht jetzt in Fs_lcd_aktleist aktuelle Leistung in 10 Wh
   Fs_lcd_aktleist_int = Fs_lcd_aktleist


   If Fs_lcd_aktleist_int > 0 Then
      I = Fs_lcd_aktleist_int Mod 10
      B = I
 '  Elseif Fs_lcd_aktleist_int > 999 Then
 '     B = 128
   Else
      B = 10
   End If
   Fs_lcd_3seg_display 64 , B

   If Fs_lcd_aktleist_int > 9 Then
      Fs_lcd_aktleist_int = Fs_lcd_aktleist_int - I
      I = Fs_lcd_aktleist_int Mod 100
      I = I / 10
      B = I
'   Elseif Fs_lcd_aktleist_int > 999 Then
'      B = 128
   Else
      B = 10
   End If
   Fs_lcd_3seg_display 66 , B

   If Fs_lcd_aktleist_int > 99 Then
      I = I * 10
      Fs_lcd_aktleist_int = Fs_lcd_aktleist_int - I
      Fs_lcd_aktleist_int = Fs_lcd_aktleist_int / 100
      B = Fs_lcd_aktleist_int
'   Elseif Fs_lcd_aktleist_int > 9 Then
'      B = 128
   Else
      B = 10
   End If
   Fs_lcd_3seg_display 68 , B



End Sub

Sub Fs_lcd_3seg_display(adresse As Byte , Zahl As Byte)
   '10 er Ziffer: 64/65
   '100 er Ziffer: 66/67
   '1000 er Ziffer: 68/68
   'Local Lcd_i2c_write As Byte
   'Lcd_i2c_write = 64
   'Local Lcd_i2c_read As Byte
   'Lcd_i2c_read = 65
   Local Segmente As Byte

     I2cstart
     I2cwbyte Adresse
     I2cwbyte 0

     Select Case Zahl
         Case 0:
               Segmente = 119                               '&H3F
         Case 1:
                Segmente = 20                               '
         Case 2:
                Segmente = 179                              '&H5B
         Case 3:
                Segmente = 182                              '&H4F
         Case 4:
                Segmente = 212                              '&H66
         Case 5:
                Segmente = 230                              '&H6D
         Case 6:
                Segmente = 231                              ' &H7D
         Case 7:
                Segmente = 52                               '&H07
         Case 8:
                Segmente = 247                              '&H7F
         Case 9:
                Segmente = 246                              '&H67
         Case 10:
                Segmente = 0                                '&H67

     End Select

     I2cwbyte Segmente
     I2cstop
End Sub

Sub Fs_lcd_display
   Local Sing As Single
   Local L As Long
       Incr Fs_lcd_timer
       If Fs_lcd_timer > 16 Then
            Fs_lcd_timer = 0
       Elseif Fs_lcd_timer = 11 Then
            Cls
            Locate 1 , 1
            Sing = Fs_akt_leist * 1000
            L = Sing
            Fs_lcdstring = Str(l)
            If Sing < 10 Then
               Fs_lcdstring = " " + Fs_lcdstring
            End If
            If Sing < 100 Then
               Fs_lcdstring = " " + Fs_lcdstring
            End If
            If Sing < 1000 Then
               Fs_lcdstring = " " + Fs_lcdstring
            End If
            If Sing < 10000 Then
               Fs_lcdstring = " " + Fs_lcdstring
            End If
            Fs_lcdstring = "Aktuell: " + Fs_lcdstring + " W"
            Lcd Fs_lcdstring
            Locate 2 , 1
            If Fs_schaltsignal = 1 Then
               Fs_lcdstring = "Schaltsignal An"
            Else
               Fs_lcdstring = "Schaltsignal Aus"
            End If
            Lcd Fs_lcdstring
            Locate 3 , 1
            Fs_lcdstring = "Status: OK"
            If Fs_alarmmailflag = 0 Then
               Fs_lcdstring = "Alarmmail!"
            End If
            Lcd Fs_lcdstring
       Elseif Fs_lcd_timer = 6 Then
            Cls
            Locate 1 , 1
            Fs_lcdsing2 = Fs_pulszahl - Fs_stundenstart(1)
            Fs_lcdsing2 = Fs_lcdsing2 / 1000
            If Fs_pulsfaktor <> 1000 Then
               Fs_lcdsing2 = Fs_lcdsing2 * 1000
               Fs_lcdsing2 = Fs_lcdsing2 / Fs_pulsfaktor
            End If
            Fs_lcdstring = Fusing(fs_lcdsing2 , "###.##")
            If Fs_lcdsing2 < 10 Then
               Fs_lcdstring = "  " + Fs_lcdstring
            End If
            If Fs_lcdsing2 < 100 Then
               Fs_lcdstring = " " + Fs_lcdstring
            End If
            Fs_lcdstring = "Heute:" + Fs_lcdstring + "kWh"
            Lcd Fs_lcdstring
            Locate 2 , 1
            Fs_lcdsing = Fs_pulszahl - Fs_stundenstart(1)
            Fs_lcdsing = Fs_lcdsing / Fs_anlagenleistung
            If Fs_pulsfaktor <> 1000 Then
               Fs_lcdsing = Fs_lcdsing * 1000
               Fs_lcdsing = Fs_lcdsing / Fs_pulsfaktor
            End If
            Fs_lcdstring = Fusing(fs_lcdsing , "##.##")
            If Fs_lcdsing < 10 Then
              Fs_lcdstring = "   " + Fs_lcdstring
            End If
            If Fs_lcdsing < 100 Then
               Fs_lcdstring = "  " + Fs_lcdstring
            End If
            Fs_lcdstring = Fs_lcdstring + "kWh/kWp"
            Lcd Fs_lcdstring
            Locate 3 , 1
            Fs_lcdsing = Fs_lfdmonwerte
            Fs_lcdsing = Fs_lcdsing / 1000
            Fs_lcdsing = Fs_lcdsing + Fs_lcdsing2
            Fs_lcdstring = Fusing(fs_lcdsing , "####.#")
            If Fs_lcdsing < 10 Then
               Fs_lcdstring = "  " + Fs_lcdstring
            End If
            If Fs_lcdsing < 100 Then
               Fs_lcdstring = " " + Fs_lcdstring
            End If
            Fs_lcdstring = "Monat: " + Fs_lcdstring + "kWh"
            Lcd Fs_lcdstring
            Fs_lcdsing2 = Fs_anlagenleistung
            Fs_lcdsing2 = Fs_lcdsing2 / 1000
            Fs_lcdsing = Fs_lcdsing / Fs_lcdsing2
            Fs_lcdstring = Fusing(fs_lcdsing , "###.##")
            If Fs_lcdsing < 10 Then
              Fs_lcdstring = "   " + Fs_lcdstring
            End If
            If Fs_lcdsing < 100 Then
               Fs_lcdstring = "  " + Fs_lcdstring
            End If
            Fs_lcdstring = Fs_lcdstring + "kWh/kWp"
            Locate 4 , 1
            Lcd Fs_lcdstring
       Elseif Fs_lcd_timer = 1 Then
            Cls
            Locate 1 , 1
            Lcd "FreeSol Logger"
            Locate 2 , 1
            Lcd "Version " ; Fs_version
            Locate 3 , 1
            Lcd My_s12_hostname
            If Ntp_valid = 1 Then
               Locate 4 , 1
               Fs_lcdstring = Date$
               Fs_lcdstring = Left(fs_lcdstring , 6)
               Lcd Fs_lcdstring ; "  " ; Time(netio_time)
            End If
       End If

End Sub

